VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MyTutorial"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'-------------------------
' Tutorial class
'-------------------------

'Humm. You should use this new method :
'Don't use TV As New TrueVision8 because
'it's finally very buggy. (Thanks Scott
'for this suggestion :)

' So don't add the New now but use it
' in the initialization part

Public TV           As TrueVision8
Public Scene        As Scene8
Public Inp          As InputEngine8
Public Land         As Landscape8
Public Scr          As Screen8
Public Camera       As Camera8
Public TexFactory   As TextureFactory8

Public ActualTexture As Integer
Public RollOnTexture As Integer
Public Size As Single
Public Sub DrawMenu()
   Scr.DrawFilledBox 440, 0, 640, 480, RGBA(0, 0, 1, 0.3), True
   Scr.DrawText "TrueVision Terrain Painting", 450, 20, RGBA(1, 0, 0, 1), "menu"
   Scr.DrawText "Click on a texture and", 450, 40, RGBA(0, 1, 1, 1)
   Scr.DrawText "paint it on the terrain !", 450, 55, RGBA(0, 1, 1, 1)
   Scr.DrawText "Size : " + CStr(Int(Size)) + " (+/-)", 570, 50, RGBA(0, 1, 0, 1)
   
   'Just check mouse rollover for each texture
   Dim B(6) As Boolean
   B(0) = Scr.RollOver(GetTex("snow"), GetTex("snow"), 500, 100, 600, 150, True)
   B(1) = Scr.RollOver(GetTex("snow2"), GetTex("snow2"), 500, 160, 600, 210, True)
   B(2) = Scr.RollOver(GetTex("rock"), GetTex("rock"), 500, 220, 600, 270, True)
   B(3) = Scr.RollOver(GetTex("earth"), GetTex("earth"), 500, 280, 600, 330, True)
   B(4) = Scr.RollOver(GetTex("blood"), GetTex("blood"), 500, 340, 600, 390, True)
   B(5) = Scr.RollOver(GetTex("terrain"), GetTex("terrain"), 500, 400, 600, 450, True)
   For i = 0 To 5
    If B(i) = True Then RollOnTexture = i
   Next i

End Sub

Public Sub ManageInput()
   'Mouse :
   Dim mx As Long, my As Long, b1 As Integer
   Dim Pick As CollisionResult8
   
   'Get the absolute mouse position
   Inp.GetAbsMouseState mx, my, b1
   If mx > 440 Then
    'Menu
      ActualTexture = RollOnTexture + 1
   Else
     'Terrain mousepicking
     'Use the scene Mouse Picking method only if the user clicks on the terrain
     If b1 <> 0 Then
       Set Pick = Scene.MousePicking(mx, my, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
     
       'If there is a collision, just draw the selected texture on the terrain
       If Pick.IsCollision = True Then
        Select Case ActualTexture
        
          'Paint the selected texture on the dynamic textures.
          'This method MUST NOT be called between Tv.Clear and Tv.RenderToScreen
          Case 1
           Land.DynDrawTexture GetTex("snow"), Pick.GetImpactPoint.x - Size, Pick.GetImpactPoint.z - Size, Pick.GetImpactPoint.x + Size, Pick.GetImpactPoint.z + Size, RGBA(1, 1, 1, 0.1), True
          Case 2
           Land.DynDrawTexture GetTex("snow2"), Pick.GetImpactPoint.x - Size, Pick.GetImpactPoint.z - Size, Pick.GetImpactPoint.x + Size, Pick.GetImpactPoint.z + Size, RGBA(1, 1, 1, 0.2), True
          Case 3
           Land.DynDrawTexture GetTex("rock"), Pick.GetImpactPoint.x - Size, Pick.GetImpactPoint.z - Size, Pick.GetImpactPoint.x + Size, Pick.GetImpactPoint.z + Size, RGBA(1, 1, 1, 0.2), True
          Case 4
           Land.DynDrawTexture GetTex("earth"), Pick.GetImpactPoint.x - Size, Pick.GetImpactPoint.z - Size, Pick.GetImpactPoint.x + Size, Pick.GetImpactPoint.z + Size, RGBA(1, 1, 1, 0.2), True
          Case 5
           Land.DynDrawTexture GetTex("blood"), Pick.GetImpactPoint.x - Size, Pick.GetImpactPoint.z - Size, Pick.GetImpactPoint.x + Size, Pick.GetImpactPoint.z + Size, RGBA(1, 0, 0, 0.2), True
          Case 6
           Land.DynDrawTexture GetTex("terrain"), Pick.GetImpactPoint.x - Size, Pick.GetImpactPoint.z - Size, Pick.GetImpactPoint.x + Size, Pick.GetImpactPoint.z + Size, RGBA(1, 1, 1, 0.2), True
         End Select
       End If
     End If
   End If
   
   'Keyboard
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then Camera.MoveForward 40, True
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then Camera.MoveForward -40, True
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then Camera.RotateCameraY 40
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then Camera.RotateCameraY -40
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then Size = Size - (Size < 40) * 0.1
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then Size = Size + (Size > 2) * 0.1
   
   
End Sub

Public Sub Run()
   '1. New init method (see the declarations)
   On Error Resume Next
   Set TV = New TrueVision8
   Set Scene = New Scene8
   Set Land = New Landscape8
   Set Scr = New Screen8
   Set Camera = New Camera8
   Set TexFactory = New TextureFactory8
   
   '2. Well let's initialize the engine in 640x480 fullscreen mode
   TV.EnableHardwareTL True 'for Rob :)
   TV.Init3DFullscreen 640, 480, 16
   TV.SetSearchDirectory App.Path
   TV.DisplayFPS = True

   Scene.SetSceneBackGround 0.5, 0.9, 1
   
   '3. Now create a 4x4 terrain where we will draw things.
   Land.GenerateHugeTerrain "height2.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
   Land.SetTextureScale 2, 2
   
   TexFactory.LoadTexture "terrain.bmp", "Terrain"
   TexFactory.LoadTexture "snow.dds", "Snow", , , TV_COLORKEY_BLACK
   TexFactory.LoadTexture "snow2.dds", "snow2", , , TV_COLORKEY_BLACK
   TexFactory.LoadTexture "dirt.jpg", "block"
   TexFactory.LoadTexture "earth.bmp", "earth"
   TexFactory.LoadTexture "rock.bmp", "rock"
   TexFactory.LoadTexture "blood2.dds", "blood", , , TV_COLORKEY_BLACK
   
   Land.SetTexture GetTex("Terrain")
   
   '4. Create font for right menu
   Scr.CreateUserFont "menu", "Arial", 10, True, False, False
   
   '------------------
   ' DYNAMIC TEXTURES
   '------------------
   'Create a 256x256 for each chunk of terrain.
   'Here we are creating the dynamic texture from the existing textures.
   'but remember that you can create simply black textures
   Land.CreateDynTextures 256, 256, True
   Land.SetTextureScale 1, 1
   
   'Setup the Input
   Set Inp = New InputEngine8
   'Add a cursor for the mouse
   Scene.LoadCursor "arrow.bmp", TV_COLORKEY_BLACK, 16, 16
   
   
   'Loop
   ActualTexture = 1
   Camera.SetCameraPosition 50, 50, 50
   Camera.SetCameraLookAt 60, 50, 60
   Camera.SetPlayerEyeHeight 30
   Size = 20
   Do
     'Clear the screen
     TV.Clear
     
     'Render objects
     Land.Render
     DrawMenu

     
     'Render all to the screen
     TV.RenderToScreen
     
     ManageInput
     
   Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
   
   'Shut down the engine
   Set TV = Nothing
   
End Sub

